OpenCV: cv::FileNodeIterator Class Reference

| OpenCV 3.4.2 Open Source Computer Vision

Classes | Public Member Functions | Public Attributes | Related Functions | List of all members
cv::FileNodeIterator Class Reference
Core functionality » XML/YAML Persistence

used to iterate through sequences and mappings. More...

`#include "persistence.hpp"`

## Classes
struct | SeqReader

## Public Member Functions
| FileNodeIterator ()
| The constructors. More...
| FileNodeIterator (const CvFileStorage *fs, const CvFileNode *node, size_t ofs=0)
| FileNodeIterator (const FileNodeIterator &it)
FileNode | operator* () const
| returns the currently observed element More...
FileNodeIterator & | operator++ ()
| moves iterator to the next node More...
FileNodeIterator | operator++ (int)
| moves iterator to the next node More...
FileNodeIterator & | operator+= (int ofs)
| moves iterator forward by the specified offset (possibly negative) More...
FileNodeIterator & | operator-- ()
| moves iterator to the previous node More...
FileNodeIterator | operator-- (int)
| moves iterator to the previous node More...
FileNodeIterator & | operator-= (int ofs)
| moves iterator backward by the specified offset (possibly negative) More...
FileNode | operator-> () const
| accesses the currently observed element methods More...
FileNodeIterator & | readRaw (const String &fmt, uchar *vec, size_t maxCount=(size_t) INT_MAX)
| Reads node elements to the buffer with the specified format. More...

## Public Attributes
const CvFileNode * | container
const CvFileStorage * | fs
SeqReader | reader
size_t | remaining

## Related Functions
(Note that these are not member functions.)
void | cvStartWriteRawData_Base64 (::CvFileStorage *fs, const char *name, int len, const char *dt)
template<typename _Tp >
static FileNodeIterator & | operator>> (FileNodeIterator &it, _Tp &value)
| Reads data from a file storage. More...
template<typename _Tp >
static FileNodeIterator & | operator>> (FileNodeIterator &it, std::vector< _Tp > &vec)
| Reads data from a file storage. More...
static bool | operator== (const FileNodeIterator &it1, const FileNodeIterator &it2)
static bool | operator!= (const FileNodeIterator &it1, const FileNodeIterator &it2)
static ptrdiff_t | operator- (const FileNodeIterator &it1, const FileNodeIterator &it2)
static bool | operator< (const FileNodeIterator &it1, const FileNodeIterator &it2)

## Detailed Description

used to iterate through sequences and mappings.

A standard STL notation, with node.begin(), node.end() denoting the beginning and the end of a sequence, stored in node. See the data reading sample in the beginning of the section.

Examples:
  filestorage.cpp.

## Constructor & Destructor Documentation

## ◆ FileNodeIterator() [1/3]

cv::FileNodeIterator::FileNodeIterator | ( |  | ) |

The constructors.

These constructors are used to create a default iterator, set it to specific element in a file node or construct it from another iterator.

## ◆ FileNodeIterator() [2/3]

cv::FileNodeIterator::FileNodeIterator | ( | const CvFileStorage * | fs,
|  | const CvFileNode * | node,
|  | size_t | ofs = `0`
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  fs | File storage for the iterator.
  node | File node for the iterator.
  ofs | Index of the element in the node. The created iterator will point to this element.

## ◆ FileNodeIterator() [3/3]

cv::FileNodeIterator::FileNodeIterator | ( | const FileNodeIterator & | it | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  it | Iterator to be used as initialization for the created iterator.

## Member Function Documentation

## ◆ operator*()

FileNode cv::FileNodeIterator::operator* | ( |  | ) | const

returns the currently observed element

## ◆ operator++() [1/2]

FileNodeIterator& cv::FileNodeIterator::operator++ | ( |  | ) |

moves iterator to the next node

## ◆ operator++() [2/2]

FileNodeIterator cv::FileNodeIterator::operator++ | ( | int |  | ) |

moves iterator to the next node

## ◆ operator+=()

FileNodeIterator& cv::FileNodeIterator::operator+= | ( | int | ofs | ) |

moves iterator forward by the specified offset (possibly negative)

## ◆ operator--() [1/2]

FileNodeIterator& cv::FileNodeIterator::operator-- | ( |  | ) |

moves iterator to the previous node

## ◆ operator--() [2/2]

FileNodeIterator cv::FileNodeIterator::operator-- | ( | int |  | ) |

moves iterator to the previous node

## ◆ operator-=()

FileNodeIterator& cv::FileNodeIterator::operator-= | ( | int | ofs | ) |

moves iterator backward by the specified offset (possibly negative)

## ◆ operator->()

FileNode cv::FileNodeIterator::operator-> | ( |  | ) | const

accesses the currently observed element methods

## ◆ readRaw()

FileNodeIterator& cv::FileNodeIterator::readRaw | ( | const String & | fmt,
|  | uchar * | vec,
|  | size_t | maxCount = `(size_t) INT_MAX`
| ) |  |

Reads node elements to the buffer with the specified format.

Usually it is more convenient to use operator `>>` instead of this method.

Parameters

  fmt | Specification of each array element. See format specification
  vec | Pointer to the destination array.
  maxCount | Number of elements to read. If it is greater than number of remaining elements then all of them will be read.

## Friends And Related Function Documentation

## ◆ cvStartWriteRawData_Base64()

void cvStartWriteRawData_Base64 | ( | ::CvFileStorage * | fs,
|  | const char * | name,
|  | int | len,
|  | const char * | dt
| ) |  |
| related

## ◆ operator!=()

static bool operator!= | ( | const FileNodeIterator & | it1,
|  | const FileNodeIterator & | it2
| ) |  |
| related

## ◆ operator-()

static ptrdiff_t operator- | ( | const FileNodeIterator & | it1,
|  | const FileNodeIterator & | it2
| ) |  |
| related

## ◆ operator<()

static bool operator< | ( | const FileNodeIterator & | it1,
|  | const FileNodeIterator & | it2
| ) |  |
| related

## ◆ operator==()

static bool operator== | ( | const FileNodeIterator & | it1,
|  | const FileNodeIterator & | it2
| ) |  |
| related

## ◆ operator>>() [1/2]

template<typename _Tp >

static FileNodeIterator & operator>> | ( | FileNodeIterator & | it,
|  | _Tp & | value
| ) |  |
| related

Reads data from a file storage.

## ◆ operator>>() [2/2]

template<typename _Tp >

static FileNodeIterator & operator>> | ( | FileNodeIterator & | it,
|  | std::vector< _Tp > & | vec
| ) |  |
| related

Reads data from a file storage.

## Member Data Documentation

## ◆ container

const CvFileNode* cv::FileNodeIterator::container

## ◆ fs

const CvFileStorage* cv::FileNodeIterator::fs

## ◆ reader

SeqReader cv::FileNodeIterator::reader

## ◆ remaining

size_t cv::FileNodeIterator::remaining

The documentation for this class was generated from the following file:

- core/include/opencv2/core/persistence.hpp